diff --git a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
index bca569b..4485f47 100644
--- a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
+++ b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
@@ -973,11 +1043,273 @@ public class CMCRequest {
         return bpid;
     }
 
+    /**
+     * processEncryptedPopResponse parses previous CMC response
+     * and returns the encryptedPop
+     *
+     * @param prevResponse file
+     * @param privKey
+     * @return encryptedPop and reqIdString in Object[]
+     * @author cfu
+     */
+    private static Object[] processEncryptedPopResponse(
+            String prevResponse) {
+        // the values to be returned
+        EncryptedPOP encryptedPop = null;
+        String reqIdString = null; // capture the requestId;
+
+        String method = "processEncryptedPopResponse: ";
+        System.out.println(method + " begins.");
+
+        byte[] bb = new byte[10000];
+        FileInputStream fis = null;
+        try {
+            fis = new FileInputStream(prevResponse);
+            while (fis.available() > 0)
+                fis.read(bb, 0, 10000);
+        } catch (Exception e) {
+            System.out.println(method + "Error reading the response. Exception: " + e.toString());
+            System.exit(1);
+        }
+        System.out.println(method + " previous response read.");
+
+        org.mozilla.jss.pkix.cms.SignedData cmcFullResp = null;
+        try {
+            ByteArrayInputStream bis = new ByteArrayInputStream(bb);
+            org.mozilla.jss.pkix.cms.ContentInfo cii = (org.mozilla.jss.pkix.cms.ContentInfo) org.mozilla.jss.pkix.cms.ContentInfo
+                    .getTemplate().decode(bis);
+
+            cmcFullResp = (org.mozilla.jss.pkix.cms.SignedData) cii.getInterpretedContent();
+            EncapsulatedContentInfo ci = cmcFullResp.getContentInfo();
+            OBJECT_IDENTIFIER id = ci.getContentType();
+            OBJECT_IDENTIFIER dataid = new OBJECT_IDENTIFIER("1.2.840.113549.1.7.1");
+            if (!id.equals(OBJECT_IDENTIFIER.id_cct_PKIResponse) && !id.equals(dataid)) {
+                System.out.println(method + "Invalid CMC Response Format");
+            }
+
+            if (!ci.hasContent())
+                return null;
+
+            OCTET_STRING content1 = ci.getContent();
+            ByteArrayInputStream bbis = new ByteArrayInputStream(content1.toByteArray());
+            ResponseBody responseBody = (ResponseBody) (new ResponseBody.Template()).decode(bbis);
+            SEQUENCE controlSequence = responseBody.getControlSequence();
+            int numControls = controlSequence.size();
+            System.out.println(method + "Number of controls is " + numControls);
+
+            for (int i = 0; i < numControls; i++) {
+                TaggedAttribute taggedAttr = (TaggedAttribute) controlSequence.elementAt(i);
+                OBJECT_IDENTIFIER type = taggedAttr.getType();
+
+                if (type.equals(OBJECT_IDENTIFIER.id_cmc_cMCStatusInfo)) {
+                    System.out.println(method + "Control #" + i + ": CMCStatusInfo");
+                    System.out.println(method + "   OID: " + type.toString());
+                    SET sts = taggedAttr.getValues();
+                    int numSts = sts.size();
+                    for (int j = 0; j < numSts; j++) {
+                        CMCStatusInfo cst = (CMCStatusInfo) ASN1Util.decode(CMCStatusInfo.getTemplate(),
+                                ASN1Util.encode(sts.elementAt(j)));
+                        SEQUENCE seq = cst.getBodyList();
+                        StringBuilder s = new StringBuilder("   BodyList: ");
+                        for (int k = 0; k < seq.size(); k++) {
+                            INTEGER n = (INTEGER) seq.elementAt(k);
+                            s.append(n.toString() + " ");
+                        }
+                        System.out.println(method + s);
+                        int st = cst.getStatus();
+                        if (st != CMCStatusInfo.SUCCESS && st != CMCStatusInfo.CONFIRM_REQUIRED) {
+                            String stString = cst.getStatusString();
+                            if (stString != null)
+                                System.out.println(method + "   Status String: " + stString);
+                            OtherInfo oi = cst.getOtherInfo();
+                            OtherInfo.Type t = oi.getType();
+                            if (t == OtherInfo.FAIL) {
+                                System.out.println(method + "   OtherInfo type: FAIL");
+                                System.out.println(method
+                                        + " not what we expected, because encryptedPOP.enable is true!!!! exit now");
+                                System.exit(1);
+                            } else if (t == OtherInfo.PEND) {
+                                System.out.println(method + "   OtherInfo type: PEND");
+                                PendInfo pi = oi.getPendInfo();
+                                if (pi == null) {
+                                    System.out.println(method + "PendInfo null...skipping");
+                                    continue;
+                                } else
+                                    System.out.println(method + "PendInfo present...processing...");
+                                if (pi.getPendTime() != null) {
+                                    String datePattern = "dd/MMM/yyyy:HH:mm:ss z";
+                                    SimpleDateFormat dateFormat = new SimpleDateFormat(datePattern);
+                                    Date d = pi.getPendTime().toDate();
+                                    System.out.println(method + "   Date: " + dateFormat.format(d));
+                                }
+                                OCTET_STRING pendToken = pi.getPendToken();
+                                if (pendToken != null) {
+                                    byte reqId[] = pendToken.toByteArray();
+                                    reqIdString = new String(reqId);
+                                    System.out.println(method + "   Pending request id: " + reqIdString);
+                                } else {
+                                    System.out.println(method + "missing pendToken in response");
+                                    System.exit(1);
+                                }
+                                System.out.println(method + " what we expected, as encryptedPOP.enable is true;");
+                            }
+                        } else if (st == CMCStatusInfo.SUCCESS) {
+                            System.out.println(method + "   Status: SUCCESS");
+                            System.out.println(
+                                    method + " not what we expected, because encryptedPOP.enable is true!!!! exit now");
+                            System.exit(1);
+                        }
+                    }
+                } else if (type.equals(OBJECT_IDENTIFIER.id_cmc_encryptedPOP)) {
+                    // bingo
+                    System.out.println(method + "Control #" + i + ": CMC encrypted POP");
+                    System.out.println(method + "   OID: " + type.toString());
+                    SET encryptedPOPvals = taggedAttr.getValues();
+
+                    encryptedPop = (EncryptedPOP) (ASN1Util.decode(EncryptedPOP.getTemplate(),
+                            ASN1Util.encode(encryptedPOPvals.elementAt(0))));
+                    System.out.println(method + "encryptedPOP decoded successfully");
+
+                } // we don't expect any other controls
+            } //for
+        } catch (Exception e) {
+            System.out.println(method + e);
+            System.exit(1);
+        }
+
+        System.out.println(method + "ends");
+        return new Object[] { encryptedPop, reqIdString };
+    }
+
+    /**
+     * constructDecryptedPopRequest constructs request PKIData for DecryptedPOP
+     *
+     * @param encryptedPopInfo {EncryptedPOP, reqIdString}
+     * @param privKey
+     * @return request PKIData
+     * @author cfu
+     */
+    private static PKIData constructDecryptedPopRequest(
+            Object[] encryptedPopInfo,
+            String tokenName,
+            PrivateKey privKey) {
+        PKIData pkidata = null;
+        DecryptedPOP decryptedPop = null;
+
+        String method = "constructDecryptedPopRequest: ";
+        System.out.println(method + "begins");
+        if ((encryptedPopInfo == null) || (privKey == null)) {
+            System.out.println(method + "input params encryptedPopInfo and privKey cannot be null");
+            System.exit(1);
+        }
+
+        EncryptedPOP encryptedPop = (EncryptedPOP) encryptedPopInfo[0];
+        String reqIdString = (String) encryptedPopInfo[1];
+        if ((encryptedPop == null) || (reqIdString == null)) {
+            System.out.println(method + "encryptedPopInfo content encryptedPop and reqIdString cannot be null");
+            System.exit(1);
+        }
+
+        try {
+            TaggedRequest request = encryptedPop.getRequest();
+            AlgorithmIdentifier thePOPAlgID = encryptedPop.getThePOPAlgID();
+            AlgorithmIdentifier witnessAlgID = encryptedPop.getWitnessAlgID();
+            OCTET_STRING witness = encryptedPop.getWitness();
+            ContentInfo cms = encryptedPop.getContentInfo();
+            EnvelopedData envData = (EnvelopedData) cms.getInterpretedContent();
+            EncryptedContentInfo encCI = envData.getEncryptedContentInfo();
+            SET recipients = envData.getRecipientInfos();
+            RecipientInfo recipient = (RecipientInfo) (ASN1Util.decode(RecipientInfo.getTemplate(),
+                    ASN1Util.encode(recipients.elementAt(0))));
+            System.out.println(method + " previous response parsed.");
+
+            CryptoToken token = CryptoUtil.getKeyStorageToken(tokenName);
+            SymmetricKey symKey = CryptoUtil.unwrap(
+                    token,
+                    SymmetricKey.Usage.DECRYPT,
+                    privKey,
+                    recipient.getEncryptedKey().toByteArray());
+            if (symKey == null) {
+                System.out.println(method + "symKey returned null from CryptoUtil.unwrap(). Abort!");
+                System.exit(1);
+            }
+            System.out.println(method + "symKey unwrapped.");
+
+            byte challenge[] = CryptoUtil.decryptUsingSymmetricKey(
+                    token,
+                    encCI.getEncryptedContent().toByteArray(),
+                    symKey);
+            if (challenge == null) {
+                System.out
+                        .println(method + "challenge returned null from CryptoUtil.decryptUsingSymmetricKey(). Abort!");
+                System.exit(1);
+            }
+            System.out.println(method + "challenge decrypted.");
+
+            // now verify the witness
+            try {
+                MessageDigest hash = MessageDigest.getInstance(CryptoUtil.getNameFromHashAlgorithm(witnessAlgID));
+                byte[] digest = hash.digest(challenge);
+                boolean witnessChecked = Arrays.equals(digest, witness.toByteArray());
+                if (witnessChecked) {
+                    System.out.println(method + "Yay! witness verified");
+                } else {
+                    System.out.println(method + "Oops! witness failed to verify.  Must abort!");
+                    System.exit(1);
+                }
+            } catch (Exception ex) {
+                System.out.println(method + ex);
+                System.exit(1);
+            }
+
+            // now calculate the POP Proof Value
+            byte[] popProofValue = null;
+            try {
+                System.out.println(method + "calculating POP Proof Value");
+                MessageDigest SHA2Digest = MessageDigest.getInstance("SHA256");
+                HMACDigest hmacDigest = new HMACDigest(SHA2Digest, challenge);
+                hmacDigest.update(ASN1Util.encode(request));
+                popProofValue = hmacDigest.digest();
+            } catch (Exception ex) {
+                System.out.println(method + "calculating POP Proof Value failed: " + ex);
+                System.exit(1);
+            }
+
+            int bpid = 1;
+            // now construct DecryptedPOP
+            System.out.println(method + "constructing DecryptedPOP...");
+            decryptedPop = new DecryptedPOP(new INTEGER(reqIdString), thePOPAlgID, new OCTET_STRING(popProofValue));
+            System.out.println(method + "DecryptedPOP constructed successfully");
+            System.out.println(method + "adding decryptedPop control");
+            TaggedAttribute decPop = new TaggedAttribute(new INTEGER(bpid++),
+                    OBJECT_IDENTIFIER.id_cmc_decryptedPOP,
+                    decryptedPop);
+
+            SEQUENCE reqSequence = new SEQUENCE();
+            reqSequence.addElement(request); //stuff original req
+
+            SEQUENCE controlSeq = new SEQUENCE();
+            controlSeq.addElement(decPop);
+            System.out.println(method + "decryptedPop control added");
+
+            SEQUENCE otherMsgSeq = new SEQUENCE();
+
+            pkidata = new PKIData(controlSeq, reqSequence, new SEQUENCE(), otherMsgSeq);
+        } catch (Exception e) {
+            System.out.println(method + e);
+            System.exit(1);
+        }
+
+        System.out.println(method + " completes.");
+        return pkidata;
+    }
+
     public static void main(String[] s) {
         String numRequests = null;
         String dbdir = null, nickname = null;
         String tokenName = null;
         String ifilename = null, ofilename = null, password = null, format = null;
+        String decryptedPopEnable = "false", encryptedPopResponseFile=null, privKeyId = null, decryptedPopRequestFile= null;
         String confirmCertEnable = "false", confirmCertIssuer = null, confirmCertSerial = null;
         String getCertEnable = "false", getCertIssuer = null, getCertSerial = null;
         String dataReturnEnable = "false", dataReturnData = null;
@@ -989,7 +1321,7 @@ public class CMCRequest {
         String revRequestInvalidityDatePresent = "false";
         String identificationEnable = "false", identification = null;
         String identityProofEnable = "false", identityProofSharedSecret = null;
-        String identityProofV2Enable = "false", identityProofV2SharedSecret = null, identityProofV2hashAlg = "SHA256", identityProofV2macAlg = "SHA256";
+        String identityProofV2Enable = "false", witnessSharedSecret = null, identityProofV2hashAlg = "SHA256", identityProofV2macAlg = "SHA256";
         String popLinkWitnessEnable = "false";
         String bodyPartIDs = null, lraPopWitnessEnable = "false";
 
@@ -1046,6 +1378,14 @@ public class CMCRequest {
                         ofilename = val;
                     } else if (name.equals("input")) {
                         ifilename = val;
+                    } else if (name.equals("decryptedPop.enable")) {
+                        decryptedPopEnable = val;
+                    } else if (name.equals("encryptedPopResponseFile")) {
+                        encryptedPopResponseFile = val;
+                    } else if (name.equals("request.privKeyId")) {
+                        privKeyId = val;
+                    } else if (name.equals("decryptedPopRequestFile")) {
+                        decryptedPopRequestFile = val;
                     } else if (name.equals("confirmCertAcceptance.serial")) {
                         confirmCertSerial = val;
                     } else if (name.equals("confirmCertAcceptance.issuer")) {
@@ -1092,8 +1432,8 @@ public class CMCRequest {
                         identification = val;
                     } else if (name.equals("identityProofV2.enable")) {
                         identityProofV2Enable = val;
-                    } else if (name.equals("identityProofV2.sharedSecret")) {
-                        identityProofV2SharedSecret = val;
+                    } else if (name.equals("witness.sharedSecret")) {
+                        witnessSharedSecret = val;
                     } else if (name.equals("identityProofV2.hashAlg")) {
                         identityProofV2hashAlg = val;
                     } else if (name.equals("identityProofV2.macAlg")) {
@@ -1118,45 +1458,6 @@ public class CMCRequest {
             printUsage();
         }
 
-        if (ifilename == null) {
-            System.out.println("Missing input filename for PKCS10 or CRMF.");
-            printUsage();
-        }
-
-        int num = 0;
-        if (numRequests == null) {
-            System.out.println("Missing numRequests.");
-            printUsage();
-        } else {
-            try {
-                num = Integer.parseInt(numRequests);
-            } catch (Exception ee) {
-                System.out.println("numRequests must be integer");
-                System.exit(1);
-            }
-        }
-
-        StringTokenizer tokenizer = new StringTokenizer(ifilename, " ");
-        String[] ifiles = new String[num];
-        for (int i = 0; i < num; i++) {
-            String ss = tokenizer.nextToken();
-            ifiles[i] = ss;
-            if (ss == null) {
-                System.out.println("Missing input file for the request.");
-                System.exit(1);
-            }
-        }
-
-        if (ofilename == null) {
-            System.out.println("Missing output filename for the CMC request.");
-            printUsage();
-        }
-
-        if (format == null) {
-            System.out.println("Missing format.");
-            printUsage();
-        }
-
         if (password == null) {
             System.out.println("Missing password.");
             printUsage();
